START      MOVE.L   24(A6),A1            NAME TABLE START
           MOVE.L   28(A6),D0            NAME TABLE END
           MOVE.L   32(A6),D1            NAME LIST START
*
NEXT_NAME  MOVE.L   #$0,A2
           MOVE.W   2(A6,A1.L),A2        A2 = OFFSET IN NAME LIST
           ADDA.L   D1,A2
           CMPI.B   #4,(A6,A2.L)         COMPARE LENGTH
           BEQ.S    GOT_LENGTH
ADVANCE_NL ADDQ.L   #8,A1
           CMP.L    A1,D0                CHECK FOR END OF TABLE
           BHI.S    NEXT_NAME
           MOVEQ    #-7,D0
           RTS
*
GOT_LENGTH CMPI.B   #69,1(A6,A2.L)
           BNE.S    ADVANCE_NL
           CMPI.B   #68,2(A6,A2.L)
           BNE.S    ADVANCE_NL
           CMPI.B   #73,3(A6,A2.L)
           BNE.S    ADVANCE_NL
           CMPI.B   #84,4(A6,A2.L)
           BNE.S    ADVANCE_NL
*
           MOVE.L   4(A6,A1.L),D1        D1 = EDIT ADDRESS
           LEA      EDIT_ADDR,A1
           MOVE.L   D1,(A1)
*
           MOVE.W   $110,A0              BP.INIT VECTOR
           LEA.L    DEFINE,A1
           JSR      (A0)
EXIT       RTS
*
DEFINE     DC.W     1
           DC.W     EDIT-*
           DC.B     4,'EDIT'
           DC.W     0
           DC.W     0
           DC.W     0
*
EDIT       CMPI.W   #$0201,(A6,A3.L)     LOOK FOR STRING PARAMETER
           BEQ.S    STRING
NORM_EDT   LEA      EDIT_ADDR,A2
           MOVE.L   (A2),A2
           JMP      (A2)
*
STRING     MOVE.L   24(A6),A1            NAME TABLE START
           MOVE.L   28(A6),D0            NAME TABLE END
           MOVE.L   32(A6),D1            NAME LIST START
           MOVE.L   40(A6),D2            VARIABLE VALUE LIST START
*
NXT_NAME   CMP.L    A1,D0
           BEQ.S    NOT_FOUND
           CMPI.B   #$04,(A6,A1.L)       LOOK FOR PROCEDURES
           BEQ.S    FOUND_TYPE
           CMPI.B   #$05,(A6,A1.L)       LOOK FOR FUNCTIONS
           BEQ.S    FOUND_TYPE
NEXT_ONE   ADDQ.L   #8,A1
           BRA.S    NXT_NAME
FOUND_TYPE MOVE.L   #$0,A2
           MOVE.W   2(A6,A1.L),A2
           ADDA.L   D1,A2                A2 = ADDRESS OF NAME STRING
           MOVE.B   (A6,A2.L),D3         D3 = STRING LENGTH
           MOVE.L   4(A6,A3.L),A4        A4 = VALUE LIST OFFSET
           ADDA.L   D2,A4                A4 = ABSOLUTE VALUE POINTER
           ADDA.L   #$1,A4               SET TO BYTE LENGTH
           CMP.B    (A6,A4.L),D3         COMPARE STRING LENGTH
           BNE.S    NEXT_ONE
STR_CHECK  ADDA.L   #$1,A2
           ADDA.L   #$1,A4
           MOVE.B   (A6,A2.L),D4
           MOVE.B   (A6,A4.L),D5
           ORI.B    #32,D4               MASK CASE BIT
           ORI.B    #32,D5               MASK CASE BIT
           CMP.B    D4,D5                COMPARE CHARACTERS
           BNE.S    NEXT_ONE
           SUBI.B   #$1,D3               SUBTRACT STRING LENGTH
           BNE.S    STR_CHECK            CHECK FOR END OF STRING
           MOVE.W   4(A6,A1.L),D1        D1 = LINE NUMBER
SET_LINE   MOVE.L   4(A6,A3.L),A4        A4 = VALUE LIST OFFSET
           ADDA.L   D2,A4                A4 = ABSOLUTE VALUE POINTER
           MOVE.W   D1,(A6,A4.L)         INSERT LINE NUMBER AS INTEGER VALUE
           MOVE.W   #8,2(A6,A4.L)        PART OF INTEGER VALUE
           MOVE.W   #$0203,(A6,A3.L)     CHANGE PARAMETER TO INTEGER
           BRA      NORM_EDT
NOT_FOUND  MOVEQ    #-7,D0
           RTS
*
EDIT_ADDR  DC.L     0
*
           END


